-------------------------------------------------------------------
--           RAPID - RAPID ADA PORTABLE INTERFACE DESIGNER         
--           MCC GUI PACKAGE LIBRARY - JVM IMPLEMENTATION
--           Copyright (C) 1999 Martin C. Carlisle.                
--                                                                 
-- RAPID is free software;  you can  redistribute it  and/or modify
-- it under terms of the  GNU General Public License as published  
-- by the Free Software  Foundation;  either version 2,  or (at your
-- option) any later version.  RAPID is distributed in the hope that 
-- it will be useful, but WITHOUT ANY WARRANTY;  without even the 
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
-- PURPOSE.  See the GNU General Public License for more details.  
-- You should have  received  a copy of the GNU General Public License
-- distributed with RAPID; see file COPYING.  If not, write to the 
-- Free Software Foundation,  59 Temple Place - Suite 330,  Boston, 
-- MA 02111-1307, USA.                                                 
--                                                                     
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an 
-- executable, this unit does not by itself cause the resulting 
-- executable to be covered by the GNU General Public License.  
-- This exception does not however invalidate any other reasons 
-- why the executable file might be covered by the GNU Public 
-- License.  This exception does not apply to executables which
-- are GUI design tools, or that could act as a replacement
-- for RAPID.
------------------------------------------------------------------------------
with MSSyst.Drawing;
use  MSSyst.Drawing;
with MSSyst.Drawing.Font;
with MSSyst.Drawing.FontFamily;
with MSSyst.Drawing.FontStyle;
with MSSyst.Windows.Forms;
use  MSSyst.Windows.Forms;
with MSSyst.Windows.Forms.Control;
with Ada.Unchecked_Conversion;
with MSSyst.Object;
package body Mcc.Gui.Fonts is
   ------------
   -- Create --
   ------------

   procedure Create
     (Obj    : in out Font;
      Family : in     Font_Family := Serif;
      Size   : in     Font_Size := 12;
      Style  : in     Font_Style := Plain)
   is
      use type FontStyle.Valuetype;   
      The_Style : FontStyle.Valuetype;
      The_Size : Float := Float(Size);
      The_Family : FontFamily.Ref;
   begin
      case Style is
         when Plain =>
            The_Style := FontStyle.Regular;
         when Bold =>
            The_Style := FontStyle.Bold;
         when Italic =>
            The_Style := FontStyle.Italic;
         when Bold_Italic =>
            The_Style := FontStyle.Italic + FontStyle.Bold;
      end case;
      case Family is
         when Sans_Serif =>
            The_Family := FontFamily.get_GenericSansSerif;
         when Serif =>
            The_Family := FontFamily.get_GenericSerif;
         when Monospaced =>
            The_Family := FontFamily.get_GenericMonospace;
      end case;
      Obj.My_Peer := MSSyst.Object.Ref(
         MSSyst.Drawing.Font.New_Font(
            Family => The_Family,
            Emsize => The_Size,
            Style  => The_Style));
   end Create;

   --------------
   -- Set_Font --
   --------------

   procedure Set_Font
     (Obj      : in out Sized_Object'Class;
      New_Font : in     Font)
   is
      The_Peer : Control.Ref := Control.Ref(Obj.My_Peer);         
   begin
      The_Peer.Set_Font(MSSyst.Drawing.Font.Ref(New_Font.My_Peer));
   end Set_Font;

end Mcc.Gui.Fonts;

